"""Contains custom data types."""

from enum import Enum

# fmt: off
class ROBOT_OUTPUT_DATA(Enum):
    """Defines the available robot output data for the user to access."""

    timestamp = 1                           # DOUBLE Time elapsed since the controller was started [s]
    target_q = 2                            # VECTOR6D Target joint positions
    target_qd = 3                           # VECTOR6D Target joint velocities
    target_qdd = 4                          # VECTOR6D Target joint accelerations
    target_current = 5                      # VECTOR6D Target joint currents
    target_moment = 6                       # VECTOR6D Target joint moments (torques)
    actual_q = 7                            # VECTOR6D Actual joint positions
    actual_qd = 8                           # VECTOR6D Actual joint velocities
    actual_current = 9                      # VECTOR6D Actual joint currents
    actual_current_window = 10              # VECTOR6D Actual current window
    joint_control_output = 11               # VECTOR6D Joint control currents
    actual_TCP_pose = 12                    # VECTOR6D Actual Cartesian coordinates of the tool: (x,y,z,rx,ry,rz), where rx, ry and rz is a rotation vector representation of the tool orientation
    actual_TCP_speed = 13                   # VECTOR6D Actual speed of the tool given in Cartesian coordinates. The speed is given in [m/s] and the rotational part of the TCP speed (rx, ry, rz) is the angular velocity given in [rad/s]
    actual_TCP_force = 14                   # VECTOR6D Generalized forces in the TCP. It compensates the measurement for forces and torques generated by the payload
    target_TCP_pose = 15                    # VECTOR6D Target Cartesian coordinates of the tool: (x,y,z,rx,ry,rz), where rx, ry and rz is a rotation vector representation of the tool orientation
    target_TCP_speed = 16                   # VECTOR6D Target speed of the tool given in Cartesian coordinates. The speed is given in [m/s] and the rotational part of the TCP speed (rx, ry, rz) is the angular velocity given in [rad/s]
    actual_digital_input_bits = 17          # UINT64 Current state of the digital inputs. 0-7: Standard, 8-15: Configurable, 16-17: Tool
    joint_temperatures = 18                 # VECTOR6D Temperature of each joint in degrees Celsius
    actual_execution_time = 19              # DOUBLE Controller real-time thread execution time
    robot_mode = 20                         # INT32 Robot mode
    joint_mode = 21                         # VECTOR6INT32 Joint control modes
    safety_mode = 22                        # INT32 Safety mode
    safety_status = 23                      # INT32 Safety status
    actual_tool_accelerometer = 24          # VECTOR3D Tool x, y and z accelerometer values
    speed_scaling = 25                      # DOUBLE Speed scaling of the trajectory limiter
    target_speed_fraction = 26              # DOUBLE Target speed fraction
    actual_momentum = 27                    # DOUBLE Norm of Cartesian linear momentum
    actual_main_voltage = 28                # DOUBLE Safety Control Board: Main voltage
    actual_robot_voltage = 29               # DOUBLE Safety Control Board: Robot voltage (48V)
    actual_robot_current = 30               # DOUBLE Safety Control Board: Robot current
    actual_joint_voltage = 31               # VECTOR6D Actual joint voltages
    actual_digital_output_bits = 32         # UINT64 Current state of the digital outputs. 0-7: Standard, 8-15: Configurable, 16-17: Tool
    runtime_state = 33                      # UINT32 Program state
    elbow_position = 34                     # VECTOR3D Position of robot elbow in Cartesian Base Coordinates
    elbow_velocity = 35                     # VECTOR3D Velocity of robot elbow in Cartesian Base Coordinates
    robot_status_bits = 36                  # UINT32 Bits 0-3:  Is power on | Is program running | Is teach button pressed | Is power button pressed
    safety_status_bits = 37                 # UINT32 Bits 0-10: Is normal mode | Is reduced mode | Is protective stopped | Is recovery mode | Is safeguard stopped | Is system emergency stopped | Is robot emergency stopped | Is emergency stopped | Is violation | Is fault | Is stopped due to safety
    analog_io_types = 38                    # UINT32 Bits 0-3: analog input 0 | analog input 1 | analog output 0 | analog output 1, {0=current[mA], 1=voltage[V]}
    standard_analog_input0 = 39             # DOUBLE Standard analog input 0 [mA or V]
    standard_analog_input1 = 40             # DOUBLE Standard analog input 1 [mA or V]
    standard_analog_output0 = 41            # DOUBLE Standard analog output 0 [mA or V]
    standard_analog_output1 = 42            # DOUBLE Standard analog output 1 [mA or V]
    io_current = 43                         # DOUBLE I/O current [mA]
    euromap67_input_bits = 44               # UINT32 Euromap67 input bits
    euromap67_output_bits = 45              # UINT32 Euromap67 output bits
    euromap67_24V_voltage = 46              # DOUBLE Euromap 24V voltage [V]
    euromap67_24V_current = 47              # DOUBLE Euromap 24V current [mA]
    tool_mode = 48                          # UINT32 Tool mode
    tool_analog_input_types = 49            # UINT32 Output domain {0=current[mA], 1=voltage[V]} Bits 0-1: tool_analog_input_0 | tool_analog_input_1
    tool_analog_input0 = 50                 # DOUBLE Tool analog input 0 [mA or V]
    tool_analog_input1 = 51                 # DOUBLE Tool analog input 1 [mA or V]
    tool_output_voltage = 52                # INT32 Tool output voltage [V]
    tool_output_current = 53                # DOUBLE Tool current [mA]
    tool_temperature = 54                   # DOUBLE Tool temperature in degrees Celsius
    tcp_force_scalar = 55                   # DOUBLE TCP force scalar [N]
    output_bit_registers0_to_31 = 56        # UINT32 General purpose bits
    output_bit_registers32_to_63 = 57       # UINT32 General purpose bits
    # (X=[64 .. 127]) BOOL 64 general purpose bits X: [64..127] - The upper range of the boolean output registers can be used by external RTDE clients (i.e URCAPS).
    output_bit_register_64 = 58
    output_bit_register_65 = 59
    output_bit_register_66 = 60
    output_bit_register_67 = 61
    output_bit_register_68 = 62
    output_bit_register_69 = 63
    output_bit_register_70 = 64
    output_bit_register_71 = 65
    output_bit_register_72 = 66
    output_bit_register_73 = 67
    output_bit_register_74 = 68
    output_bit_register_75 = 69
    output_bit_register_76 = 70
    output_bit_register_77 = 71
    output_bit_register_78 = 72
    output_bit_register_79 = 73
    output_bit_register_80 = 74
    output_bit_register_81 = 75
    output_bit_register_82 = 76
    output_bit_register_83 = 77
    output_bit_register_84 = 78
    output_bit_register_85 = 79
    output_bit_register_86 = 80
    output_bit_register_87 = 81
    output_bit_register_88 = 82
    output_bit_register_89 = 83
    output_bit_register_90 = 84
    output_bit_register_91 = 85
    output_bit_register_92 = 86
    output_bit_register_93 = 87
    output_bit_register_94 = 88
    output_bit_register_95 = 89
    output_bit_register_96 = 90
    output_bit_register_97 = 91
    output_bit_register_98 = 92
    output_bit_register_99 = 93
    output_bit_register_100 = 94
    output_bit_register_101 = 95
    output_bit_register_102 = 96
    output_bit_register_103 = 97
    output_bit_register_104 = 98
    output_bit_register_105 = 99
    output_bit_register_106 = 100
    output_bit_register_107 = 101
    output_bit_register_108 = 102
    output_bit_register_109 = 103
    output_bit_register_110 = 104
    output_bit_register_111 = 105
    output_bit_register_112 = 106
    output_bit_register_113 = 107
    output_bit_register_114 = 108
    output_bit_register_115 = 109
    output_bit_register_116 = 110
    output_bit_register_117 = 111
    output_bit_register_118 = 112
    output_bit_register_119 = 113
    output_bit_register_120 = 114
    output_bit_register_121 = 115
    output_bit_register_122 = 116
    output_bit_register_123 = 117
    output_bit_register_124 = 118
    output_bit_register_125 = 119
    output_bit_register_126 = 120
    output_bit_register_127 = 121
    # (X=[0 .. 47]) INT32 48 general purpose integer registers X: [0..23] - The lower range of the integer output registers is reserved for FieldBus/PLC interface usage. X: [24..47] - The upper range of the integer output registers can be used by external RTDE clients (i.e URCAPS).
    output_int_register_0 = 122
    output_int_register_1 = 123
    output_int_register_2 = 124
    output_int_register_3 = 125
    output_int_register_4 = 126
    output_int_register_5 = 127
    output_int_register_6 = 128
    output_int_register_7 = 129
    output_int_register_8 = 130
    output_int_register_9 = 131
    output_int_register_10 = 132
    output_int_register_11 = 133
    output_int_register_12 = 134
    output_int_register_13 = 135
    output_int_register_14 = 136
    output_int_register_15 = 137
    output_int_register_16 = 138
    output_int_register_17 = 139
    output_int_register_18 = 140
    output_int_register_19 = 141
    output_int_register_20 = 142
    output_int_register_21 = 143
    output_int_register_22 = 144
    output_int_register_23 = 145
    output_int_register_24 = 146
    output_int_register_25 = 147
    output_int_register_26 = 148
    output_int_register_27 = 149
    output_int_register_28 = 150
    output_int_register_29 = 151
    output_int_register_30 = 152
    output_int_register_31 = 153
    output_int_register_32 = 154
    output_int_register_33 = 155
    output_int_register_34 = 156
    output_int_register_35 = 157
    output_int_register_36 = 158
    output_int_register_37 = 159
    output_int_register_38 = 160
    output_int_register_39 = 161
    output_int_register_40 = 162
    output_int_register_41 = 163
    output_int_register_42 = 164
    output_int_register_43 = 165
    output_int_register_44 = 166
    output_int_register_45 = 167
    output_int_register_46 = 168
    output_int_register_47 = 169
    # (X=[0 .. 47]) DOUBLE 48 general purpose double registers X: [0..23] - The lower range of the double output registers is reserved for FieldBus/PLC interface usage. X: [24..47] - The upper range of the double output registers can be used by external RTDE clients (i.e URCAPS).
    output_double_register_0 = 170
    output_double_register_1 = 171
    output_double_register_2 = 172
    output_double_register_3 = 173
    output_double_register_4 = 174
    output_double_register_5 = 175
    output_double_register_6 = 176
    output_double_register_7 = 177
    output_double_register_8 = 178
    output_double_register_9 = 179
    output_double_register_10 = 180
    output_double_register_11 = 181
    output_double_register_12 = 182
    output_double_register_13 = 183
    output_double_register_14 = 184
    output_double_register_15 = 185
    output_double_register_16 = 186
    output_double_register_17 = 187
    output_double_register_18 = 188
    output_double_register_19 = 189
    output_double_register_20 = 190
    output_double_register_21 = 191
    output_double_register_22 = 192
    output_double_register_23 = 193
    output_double_register_24 = 194
    output_double_register_25 = 195
    output_double_register_26 = 196
    output_double_register_27 = 197
    output_double_register_28 = 198
    output_double_register_29 = 199
    output_double_register_30 = 200
    output_double_register_31 = 201
    output_double_register_32 = 202
    output_double_register_33 = 203
    output_double_register_34 = 204
    output_double_register_35 = 205
    output_double_register_36 = 206
    output_double_register_37 = 207
    output_double_register_38 = 208
    output_double_register_39 = 209
    output_double_register_40 = 210
    output_double_register_41 = 211
    output_double_register_42 = 212
    output_double_register_43 = 213
    output_double_register_44 = 214
    output_double_register_45 = 215
    output_double_register_46 = 216
    output_double_register_47 = 217
    # UINT32 General purpose bits (input read back) This range of the boolean input registers is reserved for FieldBus/PLC interface usage.
    input_bit_registers0_to_31 = 218
    # UINT32 General purpose bits (input read back) This range of the boolean input registers is reserved for FieldBus/PLC interface usage.
    input_bit_registers32_to_63 = 219
    # (X=[64 .. 127]) BOOL 64 general purpose bits X: [64..127] - The upper range of the boolean input registers can be used by external RTDE clients (i.e URCAPS).
    input_bit_register_64 = 220
    input_bit_register_65 = 221
    input_bit_register_66 = 222
    input_bit_register_67 = 223
    input_bit_register_68 = 224
    input_bit_register_69 = 225
    input_bit_register_70 = 226
    input_bit_register_71 = 227
    input_bit_register_72 = 228
    input_bit_register_73 = 229
    input_bit_register_74 = 230
    input_bit_register_75 = 231
    input_bit_register_76 = 232
    input_bit_register_77 = 233
    input_bit_register_78 = 234
    input_bit_register_79 = 235
    input_bit_register_80 = 236
    input_bit_register_81 = 237
    input_bit_register_82 = 238
    input_bit_register_83 = 239
    input_bit_register_84 = 240
    input_bit_register_85 = 241
    input_bit_register_86 = 242
    input_bit_register_87 = 243
    input_bit_register_88 = 244
    input_bit_register_89 = 245
    input_bit_register_90 = 246
    input_bit_register_91 = 247
    input_bit_register_92 = 248
    input_bit_register_93 = 249
    input_bit_register_94 = 250
    input_bit_register_95 = 251
    input_bit_register_96 = 252
    input_bit_register_97 = 253
    input_bit_register_98 = 254
    input_bit_register_99 = 255
    input_bit_register_100 = 256
    input_bit_register_101 = 257
    input_bit_register_102 = 258
    input_bit_register_103 = 259
    input_bit_register_104 = 260
    input_bit_register_105 = 261
    input_bit_register_106 = 262
    input_bit_register_107 = 263
    input_bit_register_108 = 264
    input_bit_register_109 = 265
    input_bit_register_110 = 266
    input_bit_register_111 = 267
    input_bit_register_112 = 268
    input_bit_register_113 = 269
    input_bit_register_114 = 270
    input_bit_register_115 = 271
    input_bit_register_116 = 272
    input_bit_register_117 = 273
    input_bit_register_118 = 274
    input_bit_register_119 = 275
    input_bit_register_120 = 276
    input_bit_register_121 = 277
    input_bit_register_122 = 278
    input_bit_register_123 = 279
    input_bit_register_124 = 280
    input_bit_register_125 = 281
    input_bit_register_126 = 282
    input_bit_register_127 = 283

    # (X=[0 .. 48]) INT32 48 general purpose integer registers X: [0..23] - The lower range of the integer input registers is reserved for FieldBus/PLC interface usage. X: [24..47] - The upper range of the integer input registers can be used by external RTDE clients (i.e URCAPS).
    input_int_register_0 = 284
    input_int_register_1 = 285
    input_int_register_2 = 286
    input_int_register_3 = 287
    input_int_register_4 = 288
    input_int_register_5 = 289
    input_int_register_6 = 290
    input_int_register_7 = 291
    input_int_register_8 = 292
    input_int_register_9 = 293
    input_int_register_10 = 294
    input_int_register_11 = 295
    input_int_register_12 = 296
    input_int_register_13 = 297
    input_int_register_14 = 298
    input_int_register_15 = 299
    input_int_register_16 = 300
    input_int_register_17 = 301
    input_int_register_18 = 302
    input_int_register_19 = 303
    input_int_register_20 = 304
    input_int_register_21 = 305
    input_int_register_22 = 306
    input_int_register_23 = 307
    input_int_register_24 = 308
    input_int_register_25 = 309
    input_int_register_26 = 310
    input_int_register_27 = 311
    input_int_register_28 = 312
    input_int_register_29 = 313
    input_int_register_30 = 314
    input_int_register_31 = 315
    input_int_register_32 = 316
    input_int_register_33 = 317
    input_int_register_34 = 318
    input_int_register_35 = 319
    input_int_register_36 = 320
    input_int_register_37 = 321
    input_int_register_38 = 322
    input_int_register_39 = 323
    input_int_register_40 = 324
    input_int_register_41 = 325
    input_int_register_42 = 326
    input_int_register_43 = 327
    input_int_register_44 = 328
    input_int_register_45 = 329
    input_int_register_46 = 330
    input_int_register_47 = 331
    input_int_register_48 = 332

    # (X=[0 .. 48]) DOUBLE 48 general purpose double registers X: [0..23] - The lower range of the double input registers is reserved for FieldBus/PLC interface usage. X: [24..47] - The upper range of the double input registers can be used by external RTDE clients (i.e URCAPS).
    input_double_register_0 = 333
    input_double_register_1 = 334
    input_double_register_2 = 335
    input_double_register_3 = 336
    input_double_register_4 = 337
    input_double_register_5 = 338
    input_double_register_6 = 339
    input_double_register_7 = 340
    input_double_register_8 = 341
    input_double_register_9 = 342
    input_double_register_10 = 343
    input_double_register_11 = 344
    input_double_register_12 = 345
    input_double_register_13 = 346
    input_double_register_14 = 347
    input_double_register_15 = 348
    input_double_register_16 = 349
    input_double_register_17 = 350
    input_double_register_18 = 351
    input_double_register_19 = 352
    input_double_register_20 = 353
    input_double_register_21 = 354
    input_double_register_22 = 355
    input_double_register_23 = 356
    input_double_register_24 = 357
    input_double_register_25 = 358
    input_double_register_26 = 359
    input_double_register_27 = 360
    input_double_register_28 = 361
    input_double_register_29 = 362
    input_double_register_30 = 363
    input_double_register_31 = 364
    input_double_register_32 = 365
    input_double_register_33 = 366
    input_double_register_34 = 367
    input_double_register_35 = 368
    input_double_register_36 = 369
    input_double_register_37 = 370
    input_double_register_38 = 371
    input_double_register_39 = 372
    input_double_register_40 = 373
    input_double_register_41 = 374
    input_double_register_42 = 375
    input_double_register_43 = 376
    input_double_register_44 = 377
    input_double_register_45 = 378
    input_double_register_46 = 379
    input_double_register_47 = 380
    input_double_register_48 = 381
    tool_output_mode = 382                   # UINT8 The current output mode
    tool_digital_output0_mode = 383          # UINT8 The current mode of digital output 0
    tool_digital_output1_mode = 384          # UINT8 The current mode of digital output 1
    payload = 385                            # DOUBLE Payload mass Kg
    payload_cog = 386                        # VECTOR3D Payload Center of Gravity (CoGx, CoGy, CoGz) m
    payload_inertia = 387                    # VECTOR6D Payload inertia matrix elements (Ixx,Iyy,Izz,Ixy,Ixz,Iyz] expressed in kg*m^2
    script_control_line = 388                # UINT32 Script line number that is actually in control of the robot given the robot is locked by one of the threads in the script. If no thread is locking the robot this field is set to '0'. Script line number should not be confused with program tree line number displayed on polyscope.
    ft_raw_wrench = 389                      # VECTOR6D Raw force and torque measurement given in the Tool Flange frame. Not compensated for forces and torques caused by the payload. Not zeroed by zero_ftsensor().
    joint_position_deviation_ratio = 390     # DOUBLE A non-negative double precision floating point value which can be used to monitor how close the robot is to triggering a C153 or C159 "joint position deviation" protective stop. A protective stop is triggered if the value is ever equal to or exceeds 1.0.
# fmt: on
